
package de.ivu.elect.business.gebietsbaum.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsarteigenschaft;

@RequestScoped
@Named(GebietsarteigenschaftConversationSelect.COMPONENT_NAME)
public class GebietsarteigenschaftConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietsarteigenschaftConversationSelect";

  @Inject
  protected transient GebietsarteigenschaftExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(GebietsarteigenschaftConversationStore.class)
  protected transient GebietsarteigenschaftConversationStore conversationStore;

  public GebietsarteigenschaftConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Gebietsarteigenschaft getEntity() {
    return getEntityInternal();
  }

  private Gebietsarteigenschaft getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Gebietsarteigenschaft entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Gebietsarteigenschaft entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Gebietsarteigenschaft attach(Gebietsarteigenschaft entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Gebietsarteigenschaft attach( de.ivu.elect.business.gebietsbaum.entity.GebietsarteigenschaftPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
